
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>ffmpeg代码实现自定义encoder / iVAN</title>

    <meta name="description" content="ffmpeg代码实现自定义encoder 1.概述 本文主要讲述如何用ffmpeg代码实现自己的encoder. 2.代码 [cpp] view plain copy   /*   *本程序主要实现一个自己的encoder并加入到encoder链中去,供api调用  *作者:缪国凯(MK)   *821486004@qq.com   *2015-6-4   */       #include &quot;stdafx.h&quot;      #ifdef __cplusplus   extern &quot;C&quot;   {   ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">ffmpeg代码实现自定义encoder</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>1、概述</h3>
<p>本文主要讲述如何用ffmpeg代码实现自己的encoder。</p>
<h3>2、代码</h3>
<p><strong>[cpp]</strong> <a href="http://blog.csdn.net/dancing_night/article/details/46360851#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/dancing_night/article/details/46360851#" rel="external nofollow noreferrer">copy</a><br />
<br /> </p>
<ol>
<li>/*  </li>
<li>*本程序主要实现一个自己的encoder并加入到encoder链中去,供api调用 </li>
<li>*作者：缪国凯（MK）  </li>
<li>*821486004@qq.com  </li>
<li>*2015-6-4  </li>
<li>*/   </li>
<li>  </li>
<li>#include "stdafx.h"  </li>
<li>  </li>
<li>#ifdef __cplusplus  </li>
<li>extern "C"  </li>
<li>{  </li>
<li>#endif  </li>
<li>#include &lt;libavformat/avformat.h&gt;  </li>
<li>#include &lt;libavcodec/avcodec.h&gt;  </li>
<li>#include &lt;libavutil/pixdesc.h&gt;  </li>
<li>#  </li>
<li>#ifdef __cplusplus  </li>
<li>};  </li>
<li>#endif  </li>
<li>  </li>
<li>#pragma comment(lib, "avcodec.lib")  </li>
<li>#pragma comment(lib, "avformat.lib")  </li>
<li>#pragma comment(lib, "avutil.lib")  </li>
<li>//#pragma comment(lib, "avdevice.lib")  </li>
<li>//#pragma comment(lib, "avfilter.lib")  </li>
<li>//#pragma comment(lib, "postproc.lib")  </li>
<li>//#pragma comment(lib, "swresample.lib")  </li>
<li>//#pragma comment(lib, "swscale.lib")  </li>
<li>  </li>
<li>static av_cold int mk_encode_init(AVCodecContext *avctx)  </li>
<li>{  </li>
<li>    const AVPixFmtDescriptor *desc = av_pix_fmt_desc_get(avctx-&gt;pix_fmt);  </li>
<li>  </li>
<li>    avctx-&gt;coded_frame = av_frame_alloc();  </li>
<li>    avctx-&gt;coded_frame-&gt;pict_type = AV_PICTURE_TYPE_I;  </li>
<li>    avctx-&gt;bits_per_coded_sample = av_get_bits_per_pixel(desc);  </li>
<li>    if(!avctx-&gt;codec_tag)  </li>
<li>        avctx-&gt;codec_tag = avcodec_pix_fmt_to_codec_tag(avctx-&gt;pix_fmt);  </li>
<li>    return 0;  </li>
<li>}  </li>
<li>  </li>
<li>static int mk_encode(AVCodecContext *avctx, AVPacket *pkt,  </li>
<li>    const AVFrame *frame, int *got_packet)  </li>
<li>{  </li>
<li>    int ret = avpicture_get_size(avctx-&gt;pix_fmt, avctx-&gt;width, avctx-&gt;height);  </li>
<li>  </li>
<li>    if (ret &lt; 0)  </li>
<li>        return ret;  </li>
<li>  </li>
<li>    if (pkt-&gt;data == NULL &amp;&amp; pkt-&gt;size == 0)  </li>
<li>    {  </li>
<li>        av_new_packet(pkt,ret);  </li>
<li>        pkt-&gt;size = ret;  </li>
<li>    }  </li>
<li>  </li>
<li>//  if ((ret = ff_alloc_packet2(avctx, pkt, ret)) &lt; 0)  </li>
<li>//      return ret;  </li>
<li>  </li>
<li>    if ((ret = avpicture_layout((const AVPicture *)frame, avctx-&gt;pix_fmt, avctx-&gt;width,  </li>
<li>        avctx-&gt;height, pkt-&gt;data, pkt-&gt;size)) &lt; 0)  </li>
<li>        return ret;  </li>
<li>  </li>
<li>//  if(avctx-&gt;codec_tag == AV_RL32("yuv2") &amp;&amp; ret &gt; 0 &amp;&amp;  </li>
<li>//      avctx-&gt;pix_fmt   == AV_PIX_FMT_YUYV422)   </li>
<li>//  {  </li>
<li>//          int x;  </li>
<li>//          for(x = 1; x &lt; avctx-&gt;height*avctx-&gt;width*2; x += 2)  </li>
<li>//              pkt-&gt;data[x] ^= 0x80;  </li>
<li>//  }  </li>
<li>    pkt-&gt;flags |= AV_PKT_FLAG_KEY;  </li>
<li>    *got_packet = 1;  </li>
<li>    return 0;  </li>
<li>}  </li>
<li>  </li>
<li>static av_cold int mk_close(AVCodecContext *avctx)  </li>
<li>{  </li>
<li>    av_frame_free(&amp;avctx-&gt;coded_frame);  </li>
<li>    return 0;  </li>
<li>}  </li>
<li>  </li>
<li>AVCodec ff_mkvideo_encoder = {  </li>
<li>    /*.name           = */"mkvideo",  </li>
<li>    /*.long_name      = */"mk video",  </li>
<li>    /*.type           = */AVMEDIA_TYPE_VIDEO,  </li>
<li>    /*.id             = */AV_CODEC_ID_MKVIDEO,  </li>
<li>    /*.capabilities = */0,  </li>
<li>    /*.supported_framerates = */NULL,  </li>
<li>    /*.pix_fmts     = */NULL,  </li>
<li>    /*.supported_samplerates = */NULL,  </li>
<li>    /*.sample_fmts  = */NULL,  </li>
<li>    /*.channel_layouts = */NULL,  </li>
<li>    /*.max_lowres       = */0,  </li>
<li>    /*.priv_class       = */NULL,  </li>
<li>    /*.profiles     = */NULL,  </li>
<li>    /*.priv_data_size   = */0,  </li>
<li>    /*.next         = */NULL,  </li>
<li>    /*.init_thread_copy = */NULL,  </li>
<li>    /*.update_thread_context = */NULL,  </li>
<li>    /*.defaults     = */NULL,  </li>
<li>    /*.init_static_data = */NULL,     </li>
<li>    /*.init           = */mk_encode_init,  </li>
<li>    /*.encode_sub       = */NULL,  </li>
<li>    /*.encode2        = */mk_encode,  </li>
<li>    /*.decode           = */NULL,  </li>
<li>    /*.close          = */mk_close,  </li>
<li>};  </li>
<li>  </li>
<li>void help()  </li>
<li>{  </li>
<li>    printf("**********************************************\n");  </li>
<li>    printf("Usage:\n");  </li>
<li>    printf("    MyMuxer [inputfile] [outputfile] \n");  </li>
<li>    printf("\n");  </li>
<li>    printf("Examples: \n");  </li>
<li>    printf("    MyMuxer a.avi a.yuv \n");  </li>
<li>    printf("**********************************************\n");    </li>
<li>}  </li>
<li>  </li>
<li>int _tmain(int argc, _TCHAR* argv[])  </li>
<li>{  </li>
<li>    if(argc &lt; 3 || (!strcmp(argv[1],"--help")))  </li>
<li>    {  </li>
<li>        help();  </li>
<li>        return 0;  </li>
<li>    }  </li>
<li>  </li>
<li>    av_register_all();  </li>
<li>    avcodec_register(&amp;ff_mkvideo_encoder);  </li>
<li>  </li>
<li>    AVFormatContext *in_fxt = NULL, *out_fxt = NULL;  </li>
<li>    AVStream *out_stream = NULL;  </li>
<li>    int video_index = -1;  </li>
<li>  </li>
<li>    if (avformat_open_input(&amp;in_fxt, argv[1], NULL, NULL) &lt; 0)  </li>
<li>    {  </li>
<li>        printf("can not open the input file context!\n");  </li>
<li>        goto end;  </li>
<li>    }  </li>
<li>    if (avformat_find_stream_info(in_fxt, NULL) &lt; 0)  </li>
<li>    {  </li>
<li>        printf("can not find the stream info!\n");  </li>
<li>        goto end;  </li>
<li>    }  </li>
<li>  </li>
<li>    if(avformat_alloc_output_context2(&amp;out_fxt, NULL, NULL, argv[2]) &lt; 0)  </li>
<li>    {  </li>
<li>        printf("can not alloc output context!\n");  </li>
<li>        goto end;  </li>
<li>    }  </li>
<li>  </li>
<li>    for (int i = 0; i &lt; in_fxt-&gt;nb_streams; i++)  </li>
<li>    {  </li>
<li>        if (in_fxt-&gt;streams[i]-&gt;codec-&gt;codec_type == AVMEDIA_TYPE_VIDEO)  </li>
<li>        {  </li>
<li>            //open decoder  </li>
<li>            if(0 &gt; avcodec_open2(in_fxt-&gt;streams[i]-&gt;codec, avcodec_find_decoder(in_fxt-&gt;streams[i]-&gt;codec-&gt;codec_id), NULL))  </li>
<li>            {  </li>
<li>                printf("can not find or open decoder!\n");  </li>
<li>                goto end;  </li>
<li>            }  </li>
<li>            video_index = i;  </li>
<li>            //new stream  </li>
<li>            out_stream = avformat_new_stream(out_fxt, NULL);  </li>
<li>            if (!out_stream)  </li>
<li>            {  </li>
<li>                printf("can not new stream for output!\n");  </li>
<li>                goto end;  </li>
<li>            }  </li>
<li>            //set codec context param  </li>
<li>            out_stream-&gt;codec-&gt;codec = avcodec_find_encoder(/*out_fxt-&gt;oformat-&gt;video_codec*/AV_CODEC_ID_MKVIDEO);  </li>
<li>            out_stream-&gt;codec-&gt;height = in_fxt-&gt;streams[i]-&gt;codec-&gt;height;  </li>
<li>            out_stream-&gt;codec-&gt;width = in_fxt-&gt;streams[i]-&gt;codec-&gt;width;  </li>
<li>  </li>
<li>            out_stream-&gt;codec-&gt;time_base = in_fxt-&gt;streams[i]-&gt;time_base;  </li>
<li>            //out_stream-&gt;codec-&gt;time_base.den = 25;  </li>
<li>  </li>
<li>            out_stream-&gt;codec-&gt;sample_aspect_ratio = in_fxt-&gt;streams[i]-&gt;codec-&gt;sample_aspect_ratio;           </li>
<li>            out_stream-&gt;codec-&gt;pix_fmt = in_fxt-&gt;streams[i]-&gt;codec-&gt;pix_fmt;  </li>
<li>  </li>
<li>            out_stream-&gt;avg_frame_rate.den = out_stream-&gt;codec-&gt;time_base.num;  </li>
<li>            out_stream-&gt;avg_frame_rate.num = out_stream-&gt;codec-&gt;time_base.den;  </li>
<li>            if (!out_stream-&gt;codec-&gt;codec)  </li>
<li>            {  </li>
<li>                printf("can not find the encoder!\n");  </li>
<li>                goto end;  </li>
<li>            }  </li>
<li>            if ((avcodec_open2(out_stream-&gt;codec, out_stream-&gt;codec-&gt;codec, NULL)) &lt; 0)  </li>
<li>            {  </li>
<li>                printf("can not open the encoder\n");  </li>
<li>                goto end;  </li>
<li>            }  </li>
<li>            if (out_fxt-&gt;oformat-&gt;flags &amp; AVFMT_GLOBALHEADER)  </li>
<li>                out_stream-&gt;codec-&gt;flags |= CODEC_FLAG_GLOBAL_HEADER;  </li>
<li>            break;  </li>
<li>        }  </li>
<li>    }  </li>
<li>  </li>
<li>    if (-1 == video_index)  </li>
<li>    {  </li>
<li>        printf("found no video stream in input file!\n");  </li>
<li>        goto end;  </li>
<li>    }  </li>
<li>  </li>
<li>    if (!(out_fxt-&gt;oformat-&gt;flags &amp; AVFMT_NOFILE))  </li>
<li>    {  </li>
<li>        if(avio_open(&amp;out_fxt-&gt;pb, argv[2], AVIO_FLAG_WRITE) &lt; 0)  </li>
<li>        {  </li>
<li>            printf("can not open output file handle!\n");  </li>
<li>            goto end;  </li>
<li>        }  </li>
<li>    }  </li>
<li>  </li>
<li>    if(avformat_write_header(out_fxt, NULL) &lt; 0)  </li>
<li>    {  </li>
<li>        printf("can not write the header of the output file!\n");  </li>
<li>        goto end;  </li>
<li>    }  </li>
<li>  </li>
<li>    AVPacket pkt_in, pkt_out;  </li>
<li>    AVFrame *frame;  </li>
<li>    frame = av_frame_alloc();  </li>
<li>    av_init_packet(&amp;pkt_in);  </li>
<li>    av_init_packet(&amp;pkt_out);  </li>
<li>    int got_frame, got_picture;  </li>
<li>    int i = 0, frame_index = 0;  </li>
<li>    while(1)  </li>
<li>    {  </li>
<li>        got_frame = -1;  </li>
<li>        got_picture = -1;  </li>
<li>        if (av_read_frame(in_fxt, &amp;pkt_in) &lt; 0)  </li>
<li>        {  </li>
<li>            break;  </li>
<li>        }  </li>
<li>        if (avcodec_decode_video2(in_fxt-&gt;streams[video_index]-&gt;codec, frame, &amp;got_frame, &amp;pkt_in) &lt; 0)  </li>
<li>        {  </li>
<li>            printf("can not decoder a frame");  </li>
<li>            break;  </li>
<li>        }  </li>
<li>        av_free_packet(&amp;pkt_in);  </li>
<li>  </li>
<li>        if (got_frame)  </li>
<li>        {  </li>
<li>            frame-&gt;pts = i++;  </li>
<li>            pkt_out.data = NULL;//主要这里必须自己初始化，或者必须置为null，不然ff_alloc_packet2函数会报错  </li>
<li>            pkt_out.size = 0;  </li>
<li>            if (avcodec_encode_video2(out_stream-&gt;codec, &amp;pkt_out, frame, &amp;got_picture) &lt; 0)  </li>
<li>            {  </li>
<li>                printf("can not encode a frame!\n");  </li>
<li>                break;  </li>
<li>            }  </li>
<li>  </li>
<li>            if (got_picture)  </li>
<li>            {  </li>
<li>                printf("Succeed to encode frame: %5d\tsize:%5d\n",frame_index,pkt_out.size);  </li>
<li>                pkt_out.stream_index = out_stream-&gt;index;  </li>
<li>                frame_index++;  </li>
<li>                av_write_frame(out_fxt, &amp;pkt_out);  </li>
<li>                av_free_packet(&amp;pkt_out);  </li>
<li>            }  </li>
<li>        }  </li>
<li>    }  </li>
<li>    av_frame_free(&amp;frame);  </li>
<li>  </li>
<li>    av_write_trailer(out_fxt);  </li>
<li>  </li>
<li>    //clean  </li>
<li>    avcodec_close(out_stream-&gt;codec);  </li>
<li>    avcodec_close(out_fxt-&gt;streams[video_index]-&gt;codec);  </li>
<li>end:  </li>
<li>    avformat_close_input(&amp;in_fxt);  </li>
<li>  </li>
<li>    if (out_fxt &amp;&amp; !(out_fxt-&gt;oformat-&gt;flags &amp; AVFMT_NOFILE))  </li>
<li>    {  </li>
<li>        avio_close(out_fxt-&gt;pb);  </li>
<li>    }  </li>
<li>    avformat_free_context(out_fxt);  </li>
<li>    return 0;  </li>
<li>}  </li>
</ol>
<h3>3、解释</h3>
<p>原理和前面的自定义的muxer、demuxer一样，在这里就不多说了。</p>
<p>from:http://blog.csdn.net/dancing_night/article/details/46360851</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-13 01:57:36</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/open/" title="open">open</a>, <a href="https://www.iamivan.net/tag/stream/" title="stream">stream</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>ffmpeg代码实现自定义encoder的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My3x9kz.html" rel="bookmark">代码-安卓自定义Activity搭建框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 安卓自定义Activity搭建框架 我想简化代码,自定义Activity放入自定义的Titlebar和BottomBar但是不知道该怎么下手,求高手指点,或者有相关的安卓框架视频推荐吗 解决方案 写一个基类,自定义从这个基类继承,基类中设置title和bottom 解决方案二: 写两个布局文件,在activity中include里添加进去,作为titlebar和bottombar. 解决方案三: 你在基类里面定义接口,然后在子类里面都实现,这样不同的activity就可以做不同的操作了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqRwdGp.html" rel="bookmark">solr入门之edismax权重排序使用之Java代码实现自定义权重</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				package com.git.edismax;   import java.io.IOException;      import org.apache.solr.client.solrj.SolrClient;   import org.apache.solr.client.solrj.SolrQuery;   import org.apache.solr.client.solrj.SolrServerException;   import org.apache.solr.client.so			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn4KmAb.html" rel="bookmark">JSP实现用于自动生成表单标签html代码的自定义表单标签&lowbar;JSP编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了JSP实现用于自动生成表单标签html代码的自定义表单标签.分享给大家供大家参考.具体如下: 这个是自己写的一个简单的JSP表单标签,用于自动生成checkbox,select,radio等标签,传入菜单集合生成html代码,自动选中指定值,用于java web项目的jsp页面. 1. Servlet部分代码: Map&lt;String, String&gt; map = new HashMap&lt;String, String&gt;(); map.put(&quot;2&quot;,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boRKV3z.html" rel="bookmark">FFMPeg代码分析：AVCodecContext结构体</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在调用avformat_open_input打开文件后,下一步调用av_find_stream_info函数从文件中读取音视频流的信息,而后AVFormatContext的结构体将会将这些信息保存在其中.在找到AVFormatContext的视频stream后,获取其codec保存到指向AVCodecContext的指针: // Find the first video stream for(i=0; i&lt;pFormatCtx-&gt;nb_streams; i++) { if(pFormatCtx			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVN9xKz.html" rel="bookmark">代码-Android自定义Adapter重写的getView&lpar;&rpar;不执行</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Android自定义Adapter重写的getView()不执行 想写个邮箱自动补全直接用了系统的下拉菜单 这是Adapter的代码 getView()方法不执行 解决方案 请参考 http://blog.csdn.net/ye_scofield/article/details/39252833 解决方案二: @Overridepublic int getCount() { // TODO Auto-generated method stub return bills.size();}			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrW5vjp.html" rel="bookmark">FFMPeg代码分析：AVFormatContext结构体</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				从先前的demo中可以看到,进入main函数所定义的第一个变量就是AVFormatContext的指针: int main(int argc, char *argv[]) { AVFormatContext *pFormatCtx = NULL; .... } 而且,往下看就会知道这个结构体将贯穿函数始终,avformat_open_input.av_find_stream_info.av_read_frame.av_close_input_file都需要这个结构作为参数.该结构在FFMPEG中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnK0jKz.html" rel="bookmark">FFMPeg代码分析：AVCodec结构体以及编解码器的查找和加载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				书接上回.在调用av_find_stream_info函数分析媒体文件并找到其中的视频流之后,视频流的相关信息被存放在了AVFormatContext结构体实例中.此时AVCodecContext实例所保存的AVCodec仍然为空.该结构体的定义如下: typedef struct AVCodec { const char *name;//codec名称,如果是解码HEVC的文件,那就是&quot;hevc&quot; const char *long_name;//codec全名,&quot;HEVC(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgWRGZM.html" rel="bookmark">DataSet能在CS代码里自定义查询语句吗？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 DataSet链的数据库,用ObjectDataSource绑定.有没有办法能把查询语句写在CS代码里? 解决方案 解决方案二:可以啊,DataAdapter.Fill(ds)解决方案三:使用ADO.net,下载个SQLHelper.cs,或者自己封装一个即可建议你还是先熟悉下ADO解决方案四:引用楼主sundalian3813的回复: DataSet链的数据库,用ObjectDataSource绑定.有没有办法能把查询语句写在CS代码里? ado.net的相关类就是干这个活的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1Rd8rp.html" rel="bookmark">Notepad&plus;&plus;代码编辑器自定义快捷键设置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  我们先打开一个界面:在这个界面里我们来进行讲解吧. 第一步:打开软件的界面,点击运行: 第二步:点击保存,(在输入运行程序名这里是你新建程序自带的名字,你不需要管) 第三步:点击保存以后.你会看到一个快捷键设置的窗口,在这里你可以自己设置快捷键的名称和快捷键的操作 第四步:在上述步骤设置好以后,你就可以返回主界面,点击运行,然后点击&quot;管理快捷键&quot; 第五步:跳转到这个界面,就是这个软件所有的快捷键,你不但可以看到系统只带的,还可以看到你之前设置的快捷键 第六步:点击其中的某一个,点击			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZBvOz.html" rel="bookmark" class="title">ios-UITableView从jsonURL加载数据</a>
					<div>
						问题描述 UITableView从jsonURL加载数据 在UITableview的JSON的URL绑定数据,但是在执行过程中报错. NSData *response = [NSURLConnecti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDLdKz.html" rel="bookmark" class="title">JAVA代码编写的30条建议 选择自 chinaewolf 的 Blog</a>
					<div>
						1) 类名首字母应该大写.字段.方法以及对象(句柄)的首字母应小写.对于所有标识符,其中包含的所有单词都应紧靠在一起,而且大写中间单词的首字母.例如: ThisIsAClassName thisIsM ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQQaGb.html" rel="bookmark" class="title">SEO如何让蜘蛛适应你</a>
					<div>
						在保证网站内容的质量前提下,与其说做网站是针对用户体验,不如说做网站是针对搜索引擎,说针对搜索引擎不如说是针对蜘蛛,既如此,了解蜘蛛的工作原理,熟悉蜘蛛的抓取方式成为重中之重,先满足蜘蛛后,才能通过搜 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ4Boz.html" rel="bookmark" class="title">如何操作文本文件</a>
					<div>
						前言 本文讲述如何创建文件文件,并向文本文件中追加信息 实现 假如你的web form中有一个名为txtRead的多行文本框.两个名称分别为btnReadFile.btnWriteFile的按钮. 给 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGj84op.html" rel="bookmark" class="title">linux中邮件系统及电子邮件概述</a>
					<div>
						1.邮件系统角色 MUA(邮件用户代理).MTA(邮件传输代理).MDA(邮件分发代理).MAA(邮件访问代理) MUA: (Mail User Agent): 邮件用户代理:就是用户与电子邮件系统的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBK22AM.html" rel="bookmark" class="title">WPS中如何制作表格的斜线表头？</a>
					<div>
						  有位做老师的朋友说,在编辑表格时,因为姓名和科目在同一单元格内,不知道怎么添加表格里带斜线的表头,新客网的小编实际操作了一番,教程如下(可能还有其他方法,在此仅列举一种方法) 首先选中要添加斜线的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaR8Az.html" rel="bookmark" class="title">小U盘&OpenCurlyDoubleQuote;扩容&rdquo;的一个方法</a>
					<div>
						  如果将目标内容保存到U盘之前,先对其进行压缩操作,之后再将它保存到U盘中的话,就能间接地达到为U盘扩容的目的;为此,我们可以按照如下步骤,让U盘自动在保存文件之前先对其进行压缩操作: 首先在系统桌 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKk98nb.html" rel="bookmark" class="title">设置的系统还原点不起作用的原因</a>
					<div>
						  出现还原点故障的可能原因入如下: 1.受&quot;系统还原&quot;监视的分区中可用磁盘空间太少.请确保还原过程包括&quot;系统还原&quot;创建一个还原操作之前的还原点,这样用户才可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjO54b.html" rel="bookmark" class="title">Mac终端创建文件教程</a>
					<div>
						  当然用户在使用mac的时候创建文件的方法有很多,但是有时候需要创建大容量空白文件就需要用的终端命令了,想要在Mac OS X系统中创建大容量空白文件其实非常简单.今天为大家介绍两种方式,第一种就是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bad25mz.html" rel="bookmark" class="title">Objective-C中的老板是这样发通知的（Notification&rpar;</a>
					<div>
						    ​    ​通知(Notification)简单的类比一下,公司的老总给下面的员工发通知啦,说明天公司要上市,各部门做一下准备工作.等通知发完,各部门收到后各司其职,做着自己该做的东西.假如B ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3NO3M.html" rel="bookmark" class="title">titlebar-使用标题栏时遇到的问题</a>
					<div>
						问题描述 使用标题栏时遇到的问题 我用下面的代码插入一个标题栏.我想在标题栏的最左边和最右边各添加两个标题.但是按钮不能在标题栏上显示出来.TextView 用做标题栏 &lt;TextViewand ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKJ2kM.html" rel="bookmark" class="title">App刷量企业浮出水面 黑色收入年过百万</a>
					<div>
						苹果一次惯例调查,令奇虎360旗下所有移动应用下架,也令一条借APP Store排名牟利的黑色利益链浮出水面. &quot;雇水军为软件刷下载量.好评,给对手恶评,不是秘密了.&quot; 昨日,市场 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkw07b.html" rel="bookmark" class="title">Emacs之魂（七）：变量捕获与卫生宏</a>
					<div>
						Emacs之魂(一):开篇Emacs之魂(二):一分钟学会人界用法Emacs之魂(三):列表,引用和求值策略Emacs之魂(四):标识符,符号和变量Emacs之魂(五):变量的&quot;指针&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAjv2M.html" rel="bookmark" class="title">mysql- Mybatis select 没有获取更新数据 （缓存 ？）</a>
					<div>
						问题描述 Mybatis select 没有获取更新数据 (缓存 ?) 写了一个简单的mybatis demo,没有集成其他事务管理,对接mysql数据库. 在表file_resources的mapp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW28Drb.html" rel="bookmark" class="title">dll调用-PB 调用DLL 返回值为乱码</a>
					<div>
						问题描述 PB 调用DLL 返回值为乱码 PB 使用SMS.DLL在PB中调用时,发现返回值为乱码. 推测异常原因可能是: DLL中定义的数据类型与PB数据类型不同造成. 使用DELPHI调用相同的D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLm9OZz.html" rel="bookmark" class="title">网络运维数据采集机产品设计</a>
					<div>
						问题描述 网络运维数据采集机产品设计 最近要设计一个硬件产品,专门做大型网络运行监测的数据采集,就是利用snmp.jdbc.jms等监测网络的服务器.路由器.数据库.中间件等被管理资源的cpu.内存. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLj0Zp.html" rel="bookmark" class="title">java-poi导出word &comma;中文 字体样式 问题？</a>
					<div>
						问题描述 poi导出word ,中文 字体样式 问题? poi导出word时,给中文设置 字体的类型时,不管用,打开word后,字体变成默认的&quot;宋体&quot;了,如果给英文设置,字体的类型 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0V8KM.html" rel="bookmark" class="title">Photoshop滤镜制作发光叶子</a>
					<div>
						最终效果图 1 打开Photoshop,新建立文件,设置背景颜色为黑色: 2 用钢笔工具绘制如下图形: 3 将路径转化选区,回到图层,新建一层,填充白色: 分类: PS滤镜教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7NYXp.html" rel="bookmark" class="title">有关于&sol;dev&sol;mtd&ast;文件的写操作</a>
					<div>
						问题描述 有关于/dev/mtd*文件的写操作 由于要实现文件掉电可保存的效果,想要将文件保存进/dev/mtd中,但是不知道该怎么进行写操作,百度到的资料并不多,通过fopen来打开/dev/mtd ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydXW5b.html" rel="bookmark" class="title">使用Mybatis-Generator自动生成Dao、Model、Mapping相关文件&lpar;转&rpar;</a>
					<div>
						出处:http://www.cnblogs.com/lichenwei/p/4145696.html Mybatis属于半自动ORM,在使用这个框架中,工作量最大的就是书写Mapping的映射文件,由 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1jZKz.html" rel="bookmark" class="title">浏览器-c&num; 在webbroser 打开网页 样式不起作用</a>
					<div>
						问题描述 c# 在webbroser 打开网页 样式不起作用 同一个网页 在浏览器下打开显示正常,但是在webbrowser下打开就不显示样式,这是为什么?怎么解决					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoPONM.html" rel="bookmark" class="title">DDL、DML和DCL的理解</a>
					<div>
						1.DDL       1-1.DDL的概述                DDL(Data Definition Language 数据定义语言)用于操作对象和对象的属性,这种对象包括数据库本身,以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5R2Rqz.html" rel="bookmark" class="title">ios下某些代码造成的崩溃backtrace无法定位</a>
					<div>
						问题描述 ios下某些代码造成的崩溃backtrace无法定位 如题,我在界面上建了一个crash按钮,按钮的响应函数begincrash中代码如下 这段代码会产生一个SIGSEGV信号,我在相应的信 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBxBqz.html" rel="bookmark" class="title">德国《时代》周刊：谷歌苹果与微软之间的冷战</a>
					<div>
						[&lt;财经&gt;综合报道]北京时间8月15日晚, Google宣布以125亿美元收购摩托罗拉移动.德国&lt;时代&gt;周刊发表文章认为,这表明Google,Apple和Microsoft正在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoYGAM.html" rel="bookmark" class="title">sametime 客户端之间能否跨网段传输（点对点）</a>
					<div>
						问题描述 sametime客户端之间能否点对点跨网段传输?当进行文件传输时,当点击发送,而对方接受时,进度条一直不动.过一会就显示对方已拒绝. 解决方案 本帖最后由 yaozi611 于 2010-0 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7x3rXb.html" rel="bookmark" class="title">思科农业银行广域网解决方案</a>
					<div>
						随着互联网的应用迈向一个繁荣和务实的阶段,继'政府上网工程'.'企业上网工程'的实施,'电子商务'在国内正迅猛发展.所有这一切都离不开以银行为核心的金融服务业的信息化建设,没有信息化.网络化的金融服务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmDAqp.html" rel="bookmark" class="title">认知Web服务器</a>
					<div>
						在许多用户看来,一个Web网站的成败主要在于它所提供的内容和功能,殊不知支持这些内容和功能的Web服务器才是真正的幕后英雄.据统计,全世界已有500多万个网站.每个网站的后面都运行着一个Web服务器, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEjk3z.html" rel="bookmark" class="title">外媒传马云欲维持阿里控制权 可能放弃赴港上市</a>
					<div>
						http://www.aliyun.com/zixun/aggregation/17197.html&quot;&gt;北京时间8月16日早间消息,据外媒报道,由于阿里巴巴创始人马云希望上市后能保持对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ17Zrb.html" rel="bookmark" class="title">jquery的append动态添加输入框后class无效的问题？</a>
					<div>
						问题描述 用jquery的append方法table动态添加一行,有一个输入框,用了easyui的class做验证,但是不起作用,用属性获取的方式class和precision的值都是有的,但是无法起 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk7VW5p.html" rel="bookmark" class="title">如果在等待Win开始菜单回归：那可能要失望了</a>
					<div>
						在我们的印象中,从Windows 8正式发布开始,关于开始菜单的讨论就从未停止.而Windows 8开始菜单的缺失,也诞生了第三方开始菜单这类全新的工具.从Windows 8.1的发布到Windows ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
